nopaque.app.endpoints.Users = class Users {
  constructor(app) {
    this.app = app;

    this.socket = io('/users', {transports: ['websocket'], upgrade: false});
  }

  async get(userId) {
    const response = await this.socket.emitWithAck('get', userId);

    if (response.status !== 200) {
      throw new Error(`[${response.status}] ${response.statusText}`);
    }

    return response.body;
  }

  async subscribe(userId) {
    const response = await this.socket.emitWithAck('subscribe', userId);

    if (response.status != 200) {
      throw new Error(`[${response.status}] ${response.statusText}`);
    }
  }

  async unsubscribe(userId) {
    const response = await this.socket.emitWithAck('unsubscribe', userId);

    if (response.status != 200) {
      throw new Error(`[${response.status}] ${response.statusText}`);
    }
  }

  async delete(userId) {
    const response = await this.socket.emitWithAck('delete', userId);

    if (response.status != 202) {
      throw new Error(`[${response.status}] ${response.statusText}`);
    }
  }
}
